; 
    include \masm32\include\masm32rt.inc
; 

    .686p
    .MMX
    .XMM

    include bmtemplate.inc

    iterate equ <10000000>      ; benchmark loop count
    algo_delay equ <50>        ; ms delay between each algo timing

  ; -------------------------
  ; test algorithm prototypes
  ; -------------------------
    utoa PROTO :DWORD,:DWORD
    utoa_ex PROTO :DWORD,:DWORD
    utoa2 PROTO :DWORD,:DWORD
    utoa3 PROTO :DWORD,:DWORD
    utoa_exLingo PROTO :DWORD,:DWORD
    
    SetAlgoName MACRO vname,quoted_text
    LOCAL tname
      tname db quoted_text,0
      vname dd tname
    ENDM

  .data
  ; ------------------------------------
  ; set the algorithm display names here
  ; add the names to match the test algorithms
  ; in the same order as in the test code
  ; ------------------------------------
    SetAlgoName nam1,"Ray original utoa "
    SetAlgoName nam2,"Paul Dixon utoa_ex "
    SetAlgoName nam3,"brethren utoa2 "
    SetAlgoName nam4,"Lingo utoa_ex "
    SetAlgoName nam5,"msvc ustr$ "
    SetAlgoName nam6,"Ray modified utoa3 "
    SetAlgoName nam7,"Unused "
    SetAlgoName nam8,"Unused "
  ; ------------------------------------
  ; IMPORTANT: Leave the unused slots with
  ;            the text string "Unused "
  ; The text is used to determine if there
  ; is an algorithm to include in the calculations
  ; ------------------------------------

; 

    .code

  ; ----------------------------------
  ; The test algorithms are added here
  ; ----------------------------------
    include algos.asm

start:

    invoke load_common_controls
    GLOBAL hInstance dd ?
    mov hInstance, rv(GetModuleHandle, NULL)

  ; -------------------------------------------
  ; Call the dialog box from the resource file
  ; -------------------------------------------
    invoke DialogBoxParam,hInstance,100,0,ADDR WndProc,0

    invoke ExitProcess,eax

; 

WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

      LOCAL pbuf  :DWORD
      LOCAL buffer[128]:BYTE

      STRING dlgTitle," Benchmark DWORD to ASCII Algorithms"
      GLOBAL hWnd       dd ?

    ; -----------------------
    ; Dialog control handles
    ; -----------------------
      GLOBAL hButn1     dd ?
      GLOBAL hButn2     dd ?

      GLOBAL algoname1  dd ?
      GLOBAL algoname2  dd ?
      GLOBAL algoname3  dd ?
      GLOBAL algoname4  dd ?
      GLOBAL algoname5  dd ?
      GLOBAL algoname6  dd ?
      GLOBAL algoname7  dd ?
      GLOBAL algoname8  dd ?

      GLOBAL rslt1      dd ?
      GLOBAL rslt2      dd ?
      GLOBAL rslt3      dd ?
      GLOBAL rslt4      dd ?
      GLOBAL rslt5      dd ?
      GLOBAL rslt6      dd ?
      GLOBAL rslt7      dd ?
      GLOBAL rslt8      dd ?

      GLOBAL bar1       dd ?
      GLOBAL bar2       dd ?
      GLOBAL bar3       dd ?
      GLOBAL bar4       dd ?
      GLOBAL bar5       dd ?
      GLOBAL bar6       dd ?
      GLOBAL bar7       dd ?
      GLOBAL bar8       dd ?

      GLOBAL indicate1  dd ?
      GLOBAL indicate2  dd ?
      GLOBAL indicate3  dd ?
      GLOBAL indicate4  dd ?
      GLOBAL indicate5  dd ?
      GLOBAL indicate6  dd ?
      GLOBAL indicate7  dd ?
      GLOBAL indicate8  dd ?

      GLOBAL processor  dd ?
      GLOBAL osversion  dd ?
      GLOBAL working    dd ?

      .if uMsg == WM_INITDIALOG
        m2m hWnd, hWin    ; Copy hWin to GLOBAL variable
        invoke SendMessage,hWin,WM_SETTEXT,0,ADDR dlgTitle
        invoke SendMessage,hWin,WM_SETICON,1,FUNC(LoadIcon,hInstance,5)

      ; --------------------------------
      ; Get the handle for each control
      ; --------------------------------
        mov hButn1,    rv(GetDlgItem,hWin,102)
        mov hButn2,    rv(GetDlgItem,hWin,103)         ; close button

      ; --------------------
      ; progress bar handles
      ; --------------------
        mov bar1,      rv(GetDlgItem,hWin,201)
        mov bar2,      rv(GetDlgItem,hWin,202)
        mov bar3,      rv(GetDlgItem,hWin,203)
        mov bar4,      rv(GetDlgItem,hWin,204)
        mov bar5,      rv(GetDlgItem,hWin,205)
        mov bar6,      rv(GetDlgItem,hWin,206)
        mov bar7,      rv(GetDlgItem,hWin,207)
        mov bar8,      rv(GetDlgItem,hWin,208)

      ; ---------------------
      ; algorithm name labels
      ; ---------------------
        mov algoname1, rv(GetDlgItem,hWin,105)
        mov algoname2, rv(GetDlgItem,hWin,106)
        mov algoname3, rv(GetDlgItem,hWin,107)
        mov algoname4, rv(GetDlgItem,hWin,108)
        mov algoname5, rv(GetDlgItem,hWin,109)
        mov algoname6, rv(GetDlgItem,hWin,110)
        mov algoname7, rv(GetDlgItem,hWin,111)
        mov algoname8, rv(GetDlgItem,hWin,112)

      ; -----------------------
      ; indicator radio buttons
      ; -----------------------
        mov indicate1, rv(GetDlgItem,hWin,151)
        mov indicate2, rv(GetDlgItem,hWin,152)
        mov indicate3, rv(GetDlgItem,hWin,153)
        mov indicate4, rv(GetDlgItem,hWin,154)
        mov indicate5, rv(GetDlgItem,hWin,155)
        mov indicate6, rv(GetDlgItem,hWin,156)
        mov indicate7, rv(GetDlgItem,hWin,157)
        mov indicate8, rv(GetDlgItem,hWin,158)
      ; -----------------------

        mov rslt1,     rv(GetDlgItem,hWin,301)
        mov rslt2,     rv(GetDlgItem,hWin,302)
        mov rslt3,     rv(GetDlgItem,hWin,303)
        mov rslt4,     rv(GetDlgItem,hWin,304)
        mov rslt5,     rv(GetDlgItem,hWin,305)
        mov rslt6,     rv(GetDlgItem,hWin,306)
        mov rslt7,     rv(GetDlgItem,hWin,307)
        mov rslt8,     rv(GetDlgItem,hWin,308)

        mov processor, rv(GetDlgItem,hWin,401)
        mov osversion, rv(GetDlgItem,hWin,402)
        mov working,   rv(GetDlgItem,hWin,999)

      ; -------------------------------------
      ; set the algorithm names to each label
      ; -------------------------------------
        fn SetWindowText,algoname1,nam1
        fn SetWindowText,algoname2,nam2
        fn SetWindowText,algoname3,nam3
        fn SetWindowText,algoname4,nam4
        fn SetWindowText,algoname5,nam5
        fn SetWindowText,algoname6,nam6
        fn SetWindowText,algoname7,nam7
        fn SetWindowText,algoname8,nam8

      ; ---------------------------------
      ; get the CPUID string if supported
      ; ---------------------------------

        pushad
        pushfd

        .if rv(is_cpuid) != 0
          mov pbuf, ptr$(buffer)
          invoke get_cpu_id_string,pbuf
          mov pbuf, rv(szMonoSpace,pbuf)
        .else
          sas pbuf, "CPUID not supported"
        .endif

        popfd
        popad

      ; ---------------------------------

        fn SetWindowText,processor,pbuf

        xor eax, eax
        ret

      .elseif uMsg == WM_COMMAND
        .if wParam == 102
          invoke run_benchmarks

        .elseif wParam == 103
          jmp outa_here

        .endif

      .elseif uMsg == WM_CLOSE
        outa_here:
        invoke EndDialog,hWin,0

      .endif

    xor eax, eax
    ret

WndProc endp

; 

load_common_controls proc

    LOCAL icce:INITCOMMONCONTROLSEX

  ; --------------------------------------
  ; comment out the styles you don't need.
  ; --------------------------------------
    mov icce.dwSize, SIZEOF INITCOMMONCONTROLSEX            ; set the structure size
    xor eax, eax                                            ; set EAX to zero
    or eax, ICC_ANIMATE_CLASS                               ; OR as many styles as you need to it
    or eax, ICC_BAR_CLASSES                                 ; comment out the rest
    or eax, ICC_COOL_CLASSES
    or eax, ICC_DATE_CLASSES
    or eax, ICC_HOTKEY_CLASS
    or eax, ICC_INTERNET_CLASSES
    or eax, ICC_LISTVIEW_CLASSES
    or eax, ICC_PAGESCROLLER_CLASS
    or eax, ICC_PROGRESS_CLASS
    or eax, ICC_TAB_CLASSES
    or eax, ICC_TREEVIEW_CLASSES
    or eax, ICC_UPDOWN_CLASS
    or eax, ICC_USEREX_CLASSES
    or eax, ICC_WIN95_CLASSES
    mov icce.dwICC, eax
    invoke InitCommonControlsEx,ADDR icce                   ; initialise the common control library

    ret

load_common_controls endp

; 

get_cpu_id_string proc pBuffer:DWORD

    push ebx
    push esi

    mov esi, pBuffer                    ; load buffer address into ESI
   
    mov eax, 80000002h                  ; extended function 2
    cpuid

    mov [esi],    eax                   ; write results to buffer
    mov [esi+4],  ebx
    mov [esi+8],  ecx
    mov [esi+12], edx

    mov eax, 80000003h                  ; extended function 3
    cpuid

    mov [esi+16], eax                   ; write results to buffer
    mov [esi+20], ebx
    mov [esi+24], ecx
    mov [esi+28], edx

    mov eax, 80000004h                  ; extended function 4
    cpuid

    mov [esi+32], eax                   ; write results to buffer
    mov [esi+36], ebx
    mov [esi+40], ecx
    mov [esi+44], edx

    mov [esi+48], DWORD PTR 0           ; terminate result

    pop esi
    pop ebx

    ret

get_cpu_id_string endp

; 

is_cpuid proc

    pushfd
    pop eax

    mov ecx, eax
    xor eax, 00000000001000000000000000000000b          ; set bit 21
    push eax
    popfd
    pushfd
    pop eax

    xor eax, ecx            ; test if its changed
    jz NotChanged
    mov eax, 1              ; returns 1 if CPUID is present
    ret

  NotChanged:
    xor eax, eax            ; returns 0 if its not
    ret

is_cpuid endp

; 

indicate proc arg1:DWORD

  ; -----------
  ; uncheck all
  ; -----------
    invoke SendMessage,indicate1,BM_SETCHECK,BST_UNCHECKED,0
    invoke SendMessage,indicate2,BM_SETCHECK,BST_UNCHECKED,0
    invoke SendMessage,indicate3,BM_SETCHECK,BST_UNCHECKED,0
    invoke SendMessage,indicate4,BM_SETCHECK,BST_UNCHECKED,0
    invoke SendMessage,indicate5,BM_SETCHECK,BST_UNCHECKED,0
    invoke SendMessage,indicate6,BM_SETCHECK,BST_UNCHECKED,0
    invoke SendMessage,indicate7,BM_SETCHECK,BST_UNCHECKED,0
    invoke SendMessage,indicate8,BM_SETCHECK,BST_UNCHECKED,0

  ; --------------
  ; check selected
  ; --------------
    .if arg1 == 1
      invoke SendMessage,indicate1,BM_SETCHECK,BST_CHECKED,0
    .elseif arg1 == 2
      invoke SendMessage,indicate2,BM_SETCHECK,BST_CHECKED,0
    .elseif arg1 == 3
      invoke SendMessage,indicate3,BM_SETCHECK,BST_CHECKED,0
    .elseif arg1 == 4
      invoke SendMessage,indicate4,BM_SETCHECK,BST_CHECKED,0
    .elseif arg1 == 5
      invoke SendMessage,indicate5,BM_SETCHECK,BST_CHECKED,0
    .elseif arg1 == 6
      invoke SendMessage,indicate6,BM_SETCHECK,BST_CHECKED,0
    .elseif arg1 == 7
      invoke SendMessage,indicate7,BM_SETCHECK,BST_CHECKED,0
    .elseif arg1 == 8
      invoke SendMessage,indicate8,BM_SETCHECK,BST_CHECKED,0
    .endif

  ; --------------
  ; update display
  ; --------------
    invoke SendMessage,indicate1,WM_PAINT,0,0
    invoke SendMessage,indicate2,WM_PAINT,0,0
    invoke SendMessage,indicate3,WM_PAINT,0,0
    invoke SendMessage,indicate4,WM_PAINT,0,0
    invoke SendMessage,indicate5,WM_PAINT,0,0
    invoke SendMessage,indicate6,WM_PAINT,0,0
    invoke SendMessage,indicate7,WM_PAINT,0,0
    invoke SendMessage,indicate8,WM_PAINT,0,0

    ret

indicate endp

; 

run_benchmarks proc

    LOCAL pbuf  :DWORD
    LOCAL buffer[128]:BYTE

    LOCAL dbuf  :DWORD
    LOCAL dbuffr[128]:BYTE

    LOCAL tm1   :DWORD
    LOCAL tm2   :DWORD
    LOCAL tm3   :DWORD
    LOCAL tm4   :DWORD
    LOCAL tm5   :DWORD
    LOCAL tm6   :DWORD
    LOCAL tm7   :DWORD
    LOCAL tm8   :DWORD

    LOCAL av1   :DWORD
    LOCAL av2   :DWORD
    LOCAL av3   :DWORD
    LOCAL av4   :DWORD
    LOCAL av5   :DWORD
    LOCAL av6   :DWORD
    LOCAL av7   :DWORD
    LOCAL av8   :DWORD

    LOCAL range :DWORD
    LOCAL pcnt  :DWORD
    LOCAL hFile :DWORD

    push ebx
    push esi
    push edi

    invoke EnableWindow,hButn1,FALSE
    invoke EnableWindow,hButn2,FALSE

    clear_results       ;<< MACRO

    mov pbuf, ptr$(buffer)

  ; ----------------
  ; CALIBRATION CODE
  ; ----------------
    fn SetWindowText,working,"Calibrating Algorithms"

  ; ==========================
  ; algorithm 1
  ; ==========================

    invoke SleepEx,algo_delay,0

    .if rv(szCmp,nam1,"Unused ") == 0

    invoke indicate,1

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    invoke utoa,esi,pbuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    mov tm1, eax

    .endif

  ; ==========================
  ; algorithm 2
  ; ==========================

    invoke SleepEx,algo_delay,0

    .if rv(szCmp,nam2,"Unused ") == 0

    invoke indicate,2

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    invoke utoa_ex,esi,pbuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    mov tm2, eax

    .endif

  ; ==========================
  ; algorithm 3
  ; ==========================

    invoke SleepEx,algo_delay,0

    .if rv(szCmp,nam3,"Unused ") == 0

    invoke indicate,3

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    invoke utoa2,esi,pbuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    mov tm3, eax

    .endif

  ; ==========================
  ; algorithm 4
  ; ==========================

    invoke SleepEx,algo_delay,0

    .if rv(szCmp,nam4,"Unused ") == 0

    invoke indicate,4

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    invoke utoa_exLingo,esi,pbuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    mov tm4, eax

    .endif

  ; ==========================
  ; algorithm 5
  ; ==========================

    invoke SleepEx,algo_delay,0

    .if rv(szCmp,nam5,"Unused ") == 0

    invoke indicate,5

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    mov eax, ustr$(esi)
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    mov tm5, eax

    .endif

  ; ==========================
  ; algorithm 6
  ; ==========================

    invoke SleepEx,algo_delay,0

    .if rv(szCmp,nam6,"Unused ") == 0

    invoke indicate,6

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    invoke utoa3,esi,pbuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    mov tm6, eax

    .endif

  ; ==========================
  ; algorithm 7
  ; ==========================

    invoke SleepEx,algo_delay,0

    .if rv(szCmp,nam7,"Unused ") == 0

    invoke indicate,7

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    invoke utoa2,esi,pbuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    mov tm7, eax

    .endif

  ; ==========================
  ; algorithm 8
  ; ==========================

    invoke SleepEx,algo_delay,0

    .if rv(szCmp,nam8,"Unused ") == 0

    invoke indicate,8

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    invoke utoa2,esi,pbuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    mov tm8, eax

    .endif

  ; ==========================
    calculate_display_range        ;<< MACRO
    calibration_pass_results       ;<< MACRO
  ; ==========================

  ; ---------------------------
  ; clear the average variables
  ; ---------------------------
    mov av1, 0
    mov av2, 0
    mov av3, 0
    mov av4, 0
    mov av5, 0
    mov av6, 0
    mov av7, 0
    mov av8, 0

  ; ---------------------
  ; zero the pass counter
  ; ---------------------
    mov pcnt, 0

  ; ------------------
  ; The BENCHMARK CODE
  ; ------------------
  REPEAT 8

    add pcnt, 1
    mov dbuf, ptr$(dbuffr)
    mov dbuf, cat$(dbuf,"Timing pass ",str$(pcnt))
    fn SetWindowText,working,dbuf

  ; ==========================
  ; algorithm 1
  ; ==========================

    .if rv(szCmp,nam1,"Unused ") == 0

    invoke indicate,1

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    invoke utoa,esi,pbuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    add av1, eax

    invoke SleepEx,algo_delay,0

    .endif

  ; ==========================
  ; algorithm 2
  ; ==========================

    .if rv(szCmp,nam2,"Unused ") == 0

    invoke indicate,2

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    invoke utoa_ex,esi,pbuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    add av2, eax

    invoke SleepEx,algo_delay,0

    .endif

  ; ==========================
  ; algorithm 3
  ; ==========================

    .if rv(szCmp,nam3,"Unused ") == 0

    invoke indicate,3

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    invoke utoa2,esi,pbuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    add av3, eax

    invoke SleepEx,algo_delay,0

    .endif

  ; ==========================
  ; algorithm 4
  ; ==========================

    .if rv(szCmp,nam4,"Unused ") == 0

    invoke indicate,4

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    invoke utoa_exLingo,esi,pbuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    add av4, eax

    invoke SleepEx,algo_delay,0

    .endif

  ; ==========================
  ; algorithm 5
  ; ==========================

    .if rv(szCmp,nam5,"Unused ") == 0

    invoke indicate,5

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    mov eax, ustr$(esi)
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    add av5, eax

    invoke SleepEx,algo_delay,0

    .endif

  ; ==========================
  ; algorithm 6
  ; ==========================

    .if rv(szCmp,nam6,"Unused ") == 0

    invoke indicate,6

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    invoke utoa3,esi,pbuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    add av6, eax

    invoke SleepEx,algo_delay,0

    .endif

  ; ==========================
  ; algorithm 7
  ; ==========================

    .if rv(szCmp,nam7,"Unused ") == 0

    invoke indicate,7

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    invoke utoa2,esi,pbuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    add av7, eax

    invoke SleepEx,algo_delay,0

    .endif

  ; ==========================
  ; algorithm 8
  ; ==========================

    .if rv(szCmp,nam8,"Unused ") == 0

    invoke indicate,8

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    invoke utoa2,esi,pbuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    add av8, eax

    invoke SleepEx,algo_delay,0

    .endif

  ; ==========================

  ENDM

    fn SetWindowText,working,"Average results for 8 passes. RESULTS written to bmlog.txt"

    write_results           ;<< MACRO

  ; ------------------------
  ; get the processor string
  ; ------------------------
    mov pbuf, ptr$(buffer)
    fn GetWindowText,processor,pbuf,128

    write_log_file          ;<< MACRO

    invoke EnableWindow,hButn1,TRUE
    invoke EnableWindow,hButn2,TRUE

    pop edi
    pop esi
    pop ebx

    ret

run_benchmarks endp

; 

end start

