; 
;                                        Local prototypes
; 

    WndProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
    load_common_controls PROTO
    get_cpu_id_string PROTO :DWORD
    is_cpuid PROTO
    run_benchmarks PROTO
    indicate PROTO :DWORD

; 

write_log_file MACRO

  ; ------------------
  ; WRITE THE LOG FILE
  ; ------------------
    mov hFile, fcreate("bmlog.txt")

    fprint hFile,pbuf
    fprint hFile,"Results 8 pass average"

    .if rv(szCmp,nam1,"Unused ") == 0
      mov dbuf, ptr$(dbuffr)
      mov dbuf, cat$(dbuf,"timing ",nam1,ustr$(av1)," ms")
      fprint hFile,dbuf
    .endif

    .if rv(szCmp,nam2,"Unused ") == 0
      mov dbuf, ptr$(dbuffr)
      mov dbuf, cat$(dbuf,"timing ",nam2,ustr$(av2)," ms")
      fprint hFile,dbuf
    .endif

    .if rv(szCmp,nam3,"Unused ") == 0
      mov dbuf, ptr$(dbuffr)
      mov dbuf, cat$(dbuf,"timing ",nam3,ustr$(av3)," ms")
      fprint hFile,dbuf
    .endif

    .if rv(szCmp,nam4,"Unused ") == 0
      mov dbuf, ptr$(dbuffr)
      mov dbuf, cat$(dbuf,"timing ",nam4,ustr$(av4)," ms")
      fprint hFile,dbuf
    .endif

    .if rv(szCmp,nam5,"Unused ") == 0
      mov dbuf, ptr$(dbuffr)
      mov dbuf, cat$(dbuf,"timing ",nam5,ustr$(av5)," ms")
      fprint hFile,dbuf
    .endif

    .if rv(szCmp,nam6,"Unused ") == 0
      mov dbuf, ptr$(dbuffr)
      mov dbuf, cat$(dbuf,"timing ",nam6,ustr$(av6)," ms")
      fprint hFile,dbuf
    .endif

    .if rv(szCmp,nam7,"Unused ") == 0
      mov dbuf, ptr$(dbuffr)
      mov dbuf, cat$(dbuf,"timing ",nam7,ustr$(av7)," ms")
      fprint hFile,dbuf
    .endif

    .if rv(szCmp,nam8,"Unused ") == 0
      mov dbuf, ptr$(dbuffr)
      mov dbuf, cat$(dbuf,"timing ",nam8,ustr$(av8)," ms")
      fprint hFile,dbuf
    .endif

    fclose hFile

ENDM



; 

write_results MACRO

  ; -----------------------------------
  ; divide results by 8 to get averages
  ; -----------------------------------
    shr av1, 3
    shr av2, 3
    shr av3, 3
    shr av4, 3
    shr av5, 3
    shr av6, 3
    shr av7, 3
    shr av8, 3

  ; ----------------------------------------------
  ; write results to both progress bars and labels
  ; ----------------------------------------------
    invoke SendMessage,bar1,PBM_SETPOS,av1,0
    invoke SendMessage,bar2,PBM_SETPOS,av2,0
    invoke SendMessage,bar3,PBM_SETPOS,av3,0
    invoke SendMessage,bar4,PBM_SETPOS,av4,0
    invoke SendMessage,bar5,PBM_SETPOS,av5,0
    invoke SendMessage,bar6,PBM_SETPOS,av6,0
    invoke SendMessage,bar7,PBM_SETPOS,av7,0
    invoke SendMessage,bar8,PBM_SETPOS,av8,0

    fn SetWindowText,rslt1,str$(av1)
    fn SetWindowText,rslt2,str$(av2)
    fn SetWindowText,rslt3,str$(av3)
    fn SetWindowText,rslt4,str$(av4)
    fn SetWindowText,rslt5,str$(av5)
    fn SetWindowText,rslt6,str$(av6)
    fn SetWindowText,rslt7,str$(av7)
    fn SetWindowText,rslt8,str$(av8)

    invoke indicate,0

ENDM

; 

clear_results MACRO

    mov tm1, 0
    mov tm2, 0
    mov tm3, 0
    mov tm4, 0
    mov tm5, 0
    mov tm6, 0
    mov tm7, 0
    mov tm8, 0

  ; -------------------------------------------
  ; clear the progress bars and trailing labels
  ; -------------------------------------------
    invoke SendMessage,bar1,PBM_SETPOS,0,0
    invoke SendMessage,bar2,PBM_SETPOS,0,0
    invoke SendMessage,bar3,PBM_SETPOS,0,0
    invoke SendMessage,bar4,PBM_SETPOS,0,0
    invoke SendMessage,bar5,PBM_SETPOS,0,0
    invoke SendMessage,bar6,PBM_SETPOS,0,0
    invoke SendMessage,bar7,PBM_SETPOS,0,0
    invoke SendMessage,bar8,PBM_SETPOS,0,0

    fn SetWindowText,rslt1,0
    fn SetWindowText,rslt2,0
    fn SetWindowText,rslt3,0
    fn SetWindowText,rslt4,0
    fn SetWindowText,rslt5,0
    fn SetWindowText,rslt6,0
    fn SetWindowText,rslt7,0
    fn SetWindowText,rslt8,0

ENDM

; 

calculate_display_range MACRO

  ; ------------------------------------------------------
  ; Calculate the display calibration by setting the
  ; 'range' variable to the time of the slowest algorithm.
  ; The conditional blocks determine if each of the
  ; 8 slots have an algorithm to time
  ; ------------------------------------------------------
    mov range, 0

    .if rv(szCmp,nam1,"Unused ") == 0
      mov eax, tm1
      add range, eax
    .endif

    .if rv(szCmp,nam2,"Unused ") == 0
      mov eax, tm2
      .if eax > range
        mov range, eax
      .endif
    .endif

    .if rv(szCmp,nam3,"Unused ") == 0
      mov eax, tm3
      .if eax > range
        mov range, eax
      .endif
    .endif

    .if rv(szCmp,nam4,"Unused ") == 0
      mov eax, tm4
      .if eax > range
        mov range, eax
      .endif
    .endif

    .if rv(szCmp,nam5,"Unused ") == 0
      mov eax, tm5
      .if eax > range
        mov range, eax
      .endif
    .endif

    .if rv(szCmp,nam6,"Unused ") == 0
      mov eax, tm6
      .if eax > range
        mov range, eax
      .endif
    .endif

    .if rv(szCmp,nam7,"Unused ") == 0
      mov eax, tm7
      .if eax > range
        mov range, eax
      .endif
    .endif

    .if rv(szCmp,nam8,"Unused ") == 0
      mov eax, tm8
      .if eax > range
        mov range, eax
      .endif
    .endif

  ; ---------------------------------------------------------
  ; add 50% to it to improve the display of the progress bars
  ; ---------------------------------------------------------
    mov eax, range
    shr eax, 1
    add range, eax

ENDM

; 

calibration_pass_results MACRO

    fn SetWindowText,working,"Calibrating pass results"
    invoke indicate,0

  ; ----------------------------------
  ; set the range of the progress bars
  ; ----------------------------------
    invoke SendMessage,bar1,PBM_SETRANGE32,0,range
    invoke SendMessage,bar2,PBM_SETRANGE32,0,range
    invoke SendMessage,bar3,PBM_SETRANGE32,0,range
    invoke SendMessage,bar4,PBM_SETRANGE32,0,range
    invoke SendMessage,bar5,PBM_SETRANGE32,0,range
    invoke SendMessage,bar6,PBM_SETRANGE32,0,range
    invoke SendMessage,bar7,PBM_SETRANGE32,0,range
    invoke SendMessage,bar8,PBM_SETRANGE32,0,range

  ; ----------------------------------
  ; write the calibration pass results
  ; ----------------------------------
    invoke SendMessage,bar1,PBM_SETPOS,tm1,0
    invoke SendMessage,bar2,PBM_SETPOS,tm2,0
    invoke SendMessage,bar3,PBM_SETPOS,tm3,0
    invoke SendMessage,bar4,PBM_SETPOS,tm4,0
    invoke SendMessage,bar5,PBM_SETPOS,tm5,0
    invoke SendMessage,bar6,PBM_SETPOS,tm6,0
    invoke SendMessage,bar7,PBM_SETPOS,tm7,0
    invoke SendMessage,bar8,PBM_SETPOS,tm8,0

    fn SetWindowText,rslt1,str$(tm1)
    fn SetWindowText,rslt2,str$(tm2)
    fn SetWindowText,rslt3,str$(tm3)
    fn SetWindowText,rslt4,str$(tm4)
    fn SetWindowText,rslt5,str$(tm5)
    fn SetWindowText,rslt6,str$(tm6)
    fn SetWindowText,rslt7,str$(tm7)
    fn SetWindowText,rslt8,str$(tm8)

ENDM

; 
